// Generated by CoffeeScript 2.4.1
(function() {
  var FS, UsefulWindCallServer, UsefulWindRouter, assert, debug, pkg, serialize;

  module.exports = UsefulWindCallServer = class UsefulWindCallServer {
    constructor(cfg) {
      var i, len, m, ref, ref1;
      this.cfg = cfg;
      debug('constructor');
      assert(this.cfg.use != null, 'Missing cfg.use');
      this.router = (ref = this.cfg.router) != null ? ref : new UsefulWindRouter(this.cfg);
      ref1 = this.cfg.use;
      for (i = 0, len = ref1.length; i < len; i++) {
        m = ref1[i];
        this.router.use(m);
      }
      return;
    }

    listen(port) {
      var router;
      router = this.router;
      return serialize(this.cfg, 'init').then(() => {
        this.server = FS.server(function() {
          router.route(this).catch(function(error) {
            var ref;
            return debug.dev("Router Failure", (ref = error.stack) != null ? ref : JSON.stringify(error));
          });
        });
        this.server.listen(port);
        debug(`${pkg.name} ${pkg.version}: starting on port ${port}`);
      });
    }

    stop() {
      return serialize(this.cfg, 'end').then(() => {
        var server;
        server = this.server;
        delete this.server;
        return new Promise(function(resolve, reject) {
          server.close(function(err) {
            if (err) {
              return reject(err);
            } else {
              return resolve();
            }
          });
        });
      });
    }

  };

  pkg = require('./package.json');

  debug = (require('tangible'))(`${pkg.name}:call_server`);

  UsefulWindRouter = require('./router');

  FS = require('esl');

  assert = require('assert');

  serialize = require('useful-wind-serialize');

}).call(this);
