// Generated by CoffeeScript 2.4.1
(function() {
  var UsefulWindRouter, debug, pkg, serialize,
    hasProp = {}.hasOwnProperty;

  module.exports = UsefulWindRouter = class UsefulWindRouter {
    constructor(cfg = {}) {
      this.cfg = cfg;
      debug('constructor');
      this.middlewares = [];
      this.session = {};
    }

    // router.use
    // ==========
    use(middleware) {
      // Middleware might be one of two things:
      // - a function, in which case it is a `include`-only middleware
      // - an object, in which case it must have an `include` entity as the middleware

      // At this point it should either be a function or an object.
      if (typeof middleware === 'function') {
        middleware = {
          include: middleware
        };
      } else {
        middleware = {
          include: middleware.include,
          name: middleware.name
        };
      }
      // At this point it should only be an object; the object must have an `include` function.
      if (middleware.name == null) {
        middleware.name = '(no name)';
      }
      if (typeof middleware.include === 'function') {
        // Add the middleware for in-call use.
        return this.middlewares.push(middleware);
      } else {
        return debug(`Middleware ${middleware.name}'s \`include\` must be a function`, typeof middleware.include);
      }
    }

    async route(call) {
      var ctx, destination, k, ref, source, v;
      source = call.data['Channel-Caller-ID-Number'];
      destination = call.data['Channel-Destination-Number'];
      // The above works fine if we are executing inside the XML dialplan. However when executing from within an `inline:socket` dialplan the list is different.
      if (destination == null) {
        destination = call.data.variable_sip_req_user;
      }
      ctx = {
        router: this,
        cfg: this.cfg,
        call,
        data: call.data,
        source,
        destination,
        req: {
          variable: function(name) {
            return call.data[`variable_${name}`];
          },
          header: function(name) {
            return call.data[`variable_sip_h_${name}`];
          }
        },
        res: {
          set: function(name, value) {
            if (value != null) {
              return call.command('set', `${name}=${value}`);
            } else {
              return call.command('unset', `${name}`);
            }
          },
          export: function(name, value) {
            if (value != null) {
              return call.command('export', `${name}=${value}`);
            } else {
              return call.command('export', `${name}`);
            }
          },
          header: function(name, value) {
            return call.command('export', `variable_sip_h_${name}=${value}`);
          }
        },
        session: {},
        action: function(name, args) {
          return call.command(name, args);
        }
      };
      ref = this.session;
      for (k in ref) {
        if (!hasProp.call(ref, k)) continue;
        v = ref[k];
        ctx.session[k] = v;
      }
      await serialize.modules(this.middlewares, ctx, 'include');
      debug('completed');
      return ctx;
    }

  };

  // Toolbox
  // -------
  pkg = require('./package.json');

  debug = (require('tangible'))(`${pkg.name}:router`);

  serialize = require('useful-wind-serialize');

}).call(this);
